<?php

/***************************************************************************
 *   Copyright (C) 2004 by Thomas Flueeli                                  *
 *   cairol@thatrix.net                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/ 

/***************************************************************************
 * Version                                                                 *
 *   $Id: add.php,v 1.13 2004/05/18 07:59:18 thatrix Exp $                *
 ***************************************************************************/ 

/***************************************************************************
 * History                                                                 *
 *   06.04.2003 : Initial release [thatrix]                                *
 *   10.04.2003 : Template Engine [thatrix]                                *
 *   08.05.2003 : Smilies [thatrix]                                        *
 *                Performance (str_replace instead preg_replace) [thatrix] *
 *   14.05.2003 : Global Config [thatrix]                                  *
 *   24.05.2003 : Correct use of htmlentities and stripslashes [thatrix]   *
 *   28.05.2003 : Replace \n and \r\n with ' <br>' (with a blank)          *
 *                Always disconnect database [thatrix]                     *
 *   17.11.2003 : Added IP saving [thatrix]                                *
 *   18.11.2003 : Multi language support [thatrix]                         *
 *   25.11.2003 : Table prefix [thatrix]                                   *
 *   16.02.2004 : Added Formats [thatrix]                                  *
 *   18.02.2004 : Smilies, formats are parsed when post is saved [thatrix] *
 ***************************************************************************/ 

 define('IN_PHPGB', true);
 $phpGB_base = dirname(__FILE__) . '/';
 require_once($phpGB_base . 'lib/phpGuestbook.php');

 // HTTP Header
 writeHeader();
        
 if (checkPG('Name') && checkPG('Mail') && checkPG('Post') && checkPG('Check')) {
        
        // Replace all special characters (<, >, ', ", etc)
    $name     = htmlentities($_POST['Name'], ENT_QUOTES);
    $mail     = htmlentities($_POST['Mail'], ENT_QUOTES);
    $website  = htmlentities(trim($_POST['Website']), ENT_QUOTES);
    $post     = str_replace(array("\n","\r","\r\n"), array(' <br>'), htmlentities($_POST['Post'], ENT_QUOTES));
    
    // Replace smilies and format codes
    startSmilieParser();
    $post     = parseSmilies($post);
             
    // Put http:// in front of website string, if is not there yet
    if (($website != '') && (substr($website, 0, 7) != 'http://') && (substr($website, 0, 8) != 'https://')) {
       $website = 'http://' . $website;
    }

    // Run SQL query
    $result = $DB->query('INSERT INTO ' . $config['prefix'] . "Posts(Name, EMail, Website, Post, Date, IP) VALUES('$name', '$mail', '$website', '$post', now(), '" . $_SERVER['REMOTE_ADDR'] . "');");
        
    // Redirect to index.php
    header("Location: http://" . $_SERVER['HTTP_HOST'] . $config['URL'] . 'index.php');

 } elseif (checkPG('smiliesWindow', 1)) {
    $theme = $config['Theme'];
    $template->assign('SMILIES', getSmilies());
    if (checkPG('admin', 1, true) && $_GET['admin'] == 1 ) {
            $theme = 'Standard/';
    }
    $template->assign('DIR_IMAGES'    , $config['URL'] . 'templates/' . $theme . 'images/');
    $template->assign('L_CLOSE_WINDOW', $lang['Close_window']);
    $template->assign('L_MORE_SMILIES', $lang['More_smilies']);
    $template->display($theme . 'smiliesWindow.tpl');   
 } else {
                
        // New or not all filled out?
        if (checkPG('Check')) {
                $template->assign('ERROR', 1);
        }

        // Show Form
        $template->assign('FILE_ADD'      , $config['URL'] . 'add.php'      );
        $template->assign('FILE_INDEX'    , $config['URL'] . 'index.php'    );
        $template->assign('DIR_SMILIES'   , $config['SmiliesPath']          );
        $template->assign('DIR_IMAGES'    , $config['URL'] . 'templates/' .$config['Theme'] . 'images/');
        $template->assign('NAME'          , htmlentities(stripslashes($_POST['Name'])    , ENT_QUOTES));
        $template->assign('EMAIL'         , htmlentities(stripslashes($_POST['Mail'])    , ENT_QUOTES));
        $template->assign('WEBSITE'       , htmlentities(stripslashes($_POST['Website']), ENT_QUOTES));
        $template->assign('POST'          , htmlentities(stripslashes($_POST['Post']) , ENT_QUOTES));
        $template->assign('SMILIES'       , getSmilies(23)                  );
        $template->assign('L_BACK'        , $lang['Back']);
        $template->assign('L_EMPTY_FIELDS', $lang['Empty_fields']);
        $template->assign('L_NEW_POST'    , $lang['New_post']);
        $template->assign('L_NAME'        , $lang['Name']);
        $template->assign('L_EMAIL'       , $lang['EMail']);
        $template->assign('L_WEBSITE'     , $lang['Website']);
        $template->assign('L_POST'        , $lang['Post']);
        $template->assign('L_SMILIES'     , $lang['Smilies']);
        $template->assign('L_MORE_SMILIES', $lang['More_smilies']);
        $template->assign('L_FORMAT'      , $lang['Format']);
        $template->assign('L_BOLD'        , $lang['Bold']);
        $template->assign('L_ITALIC'      , $lang['Italic']);
        $template->assign('L_UNDERLINE'   , $lang['Underline']);
        $template->assign('L_URL'         , $lang['Admin_URL']);
        $template->assign('L_SAVE'        , $lang['Save']);
        $template->display($config['Theme'] . 'add.tpl'                  );
 }
 $DB->disconnect();
?>