<?php

/***************************************************************************
 *   Copyright (C) 2004 by Thomas Flueeli                                  *
 *   cairol@thatrix.net                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/ 
 
/***************************************************************************
 * Version                                                                 *
 *   $Id: admin.php,v 1.10 2004/05/18 08:13:00 thatrix Exp $                *
 ***************************************************************************/ 

/***************************************************************************
 * History                                                                 *
 *   07.08.2003 : Initial release [thatrix]                                *
 *   04.09.2003 : Management [thatrix]                                     *
 *   17.11.2003 : Delete, Edit Posts [thatrix]                             *
 *   18.11.2003 : Multi language support [thatrix]                         *
 *   25.11.2003 : Table prefix [thatrix]                                   *
 *   18.05.2004 : Formats [thatrix]                                        *
 ***************************************************************************/
 
 define('IN_PHPGB', true);
 $phpGB_base = dirname(__FILE__) . '/';
 require_once($phpGB_base . 'lib/phpGuestbook.php');
 require_once($phpGB_base . 'admin/admin.php');
 
 if ($phpGB_Admin->getAuth()) {
        
        writeHeader();
        $template->assign('DIR_IMAGES', $config['URL'] . 'templates/Standard/images/');
        $site = 'index';
        
        // determine site to display
        if (checkPG('site', 1)) {
                $site = htmlentities(trim($_GET['site']), ENT_QUOTES);          
        } elseif(checkPG('site', 0)) {
                $site = htmlentities(trim($_POST['site']), ENT_QUOTES);
        }
        
        // display admin index (frameset)
        if ($site == 'index') {
                $template->display('Standard/admin_index.tpl'); 
        $DB->disconnect();
                exit();
        }
 
        // display navigation
        if ($site == 'nav') {
                $template->assign('L_ADMIN_HOME'      , $lang['Admin_home']);
                $template->assign('L_ADMIN_MGMT'      , $lang['Admin_mgmt']);
                $template->assign('L_ADMIN_EDIT_POSTS', $lang['Admin_edit_posts']);
                $template->assign('L_ADMIN_PREVIEW'   , $lang['Admin_preview']);
                $template->assign('L_ADMIN_LOGOUT'    , $lang['Admin_logout']);
                $template->display('Standard/admin_nav.tpl');   
        $DB->disconnect();
                exit();
        }
        
        // display admin home
        if ($site == 'home') {

                // Get Total Table Size
                $res         = $DB->query('SHOW TABLE STATUS');
                $gbSize      = 0;
                while($tableStatus = $res->fetchRow(DB_FETCHMODE_ASSOC)) {
                        $gbSize += $tableStatus['Data_length'];
                }
                $gbSize = formatBytes($gbSize);

                // Get number of posts
                $res   = $DB->query('SELECT COUNT(PostID) AS Posts FROM ' . $config['prefix'] . 'Posts');
                $row   = $res->fetchRow(DB_FETCHMODE_ASSOC);
                $count = $row['Anzahl'];

                $template->assign('POSTS', $row['Posts']              );
                $template->assign('SIZE' , $gbSize                    );
                $template->assign('L_ADMIN_INFO'     , $lang['Admin_info']);
                $template->assign('L_ADMIN_NUMBER'   , $lang['Admin_number']);
                $template->assign('L_ADMIN_SIZE'     , $lang['Admin_size']);
                $template->assign('L_ADMIN_ATTENTION', $lang['Admin_attention']);
                $template->assign('L_ADMIN_TIMEOUT'  , $lang['Admin_timeout']);
                $template->display('Standard/admin_home.tpl');  

                $res->free();
                exit();
        }

        // save settings
        if ($site == 'manage_save') {

                $updates          = array();
                $updates['Title'] = htmlentities(trim($_POST['Title']), ENT_QUOTES);
                $updates['URL']   = trim($_POST['URL']);
                $updates['Theme'] = escapeshellcmd(trim($_POST['Theme']), ENT_QUOTES) . '/';
                $updates['Language'] = escapeshellcmd(trim($_POST['Language']), ENT_QUOTES);

                if(is_numeric(trim($_POST['Posts']))) {
                        $updates['PostsPerPage'] = trim($_POST['Posts']);
                } else {
                        $updates['PostsPerPage'] = 5;
                }
                
                foreach($updates as $configName => $configValue) {
                        $result = $DB->query('UPDATE ' . $config['prefix'] . "Config SET ConfigValue = '$configValue' WHERE ConfigName = '$configName'");
                }
                
                loadConfig();
        $lang = array();
        require($phpGB_base . 'language/' . $config['Language'] . '/lang.php');                
                $site = 'manage';
        }

        // display management
        if ($site == 'manage') {
            
            $themes    = array();
            $languages = array();

                // read themes
                $dh  = opendir($phpGB_base . 'templates');
                while (false !== ($filename = readdir($dh))) {
                        if ($filename != '.' && $filename != '..' && $filename != 'index.html' && $filename != 'CVS') {
                            $themes[] = $filename;
                        }
                }

                // read languages
                $dh  = opendir($phpGB_base . 'language');
                while (false !== ($filename = readdir($dh))) {
                        if ($filename != '.' && $filename != '..' && $filename != 'index.html' && $filename != 'CVS') {
                            $languages[] = $filename;
                        }
                }

                closedir($dh);
                sort($themes);
                sort($languages);

                $template->assign('TITLE' , $config['Title']            );
                $template->assign('URL'   , $config['URL']              );
                $template->assign('POSTS' , $config['PostsPerPage']     );
                $template->assign('THEME' , rtrim($config['Theme'], '/'));
                $template->assign('THEMES', $themes                     );
                $template->assign('LANG'  , $config['Language']);
                $template->assign('LANGS' , $languages                     );
                $template->assign('ACTION', 'admin.php'                 );
                $template->assign('L_ADMIN_MGMT' , $lang['Admin_mgmt']);
                $template->assign('L_ADMIN_TITLE', $lang['Admin_title']);
                $template->assign('L_ADMIN_URL'  , $lang['Admin_URL']);
                $template->assign('L_ADMIN_PPP'  , $lang['Admin_ppp']);
                $template->assign('L_ADMIN_THEME', $lang['Admin_theme']);
                $template->assign('L_ADMIN_LANG' , $lang['Admin_lang']);
                $template->assign('L_SAVE'       , $lang['Save']);

                $template->display('Standard/admin_manage.tpl');        

        $DB->disconnect();
                exit();
        }       
        
        // delete post
        if ($site == 'delete' && checkPG('PostID', 1, true)) {
        $result = $DB->query('DELETE FROM ' . $config['prefix'] . 'Posts WHERE PostID = ' . $_GET['PostID']);
          $site = 'edit';
    }

        // save edited post
        if ($site == 'editPostSave') {
             if (checkPG('Name') && checkPG('Mail') && checkPG('Post') && checkPG('Check') && checkPG('PostID', 0, true)) {
    
               // Replace all special characters (<, >, ', ", etc)
                $name     = htmlentities($_POST['Name'], ENT_QUOTES);
                $mail     = htmlentities($_POST['Mail'], ENT_QUOTES);
                $website  = htmlentities(trim($_POST['Website']), ENT_QUOTES);
                $post     = str_replace(array("\n","\r","\r\n"), array(' <br>'), htmlentities($_POST['Post'], ENT_QUOTES));

                // Replace smilies and format codes
                startSmilieParser();
                $post     = parseSmilies($post);
                     
                // Put http:// in front of homepage string, if is not there yet
                if (($website != '') && (substr($website, 0, 7) != 'http://') && (substr($website, 0, 8) != 'https://')) {
                     $website = 'http://' . $website;
                }
        
                // Run SQL query
                $result = $DB->query('UPDATE ' . $config['prefix'] . "Posts SET Name='$name', EMail='$mail', Website='$website', Post='$post' WHERE PostID=" . $_POST['PostID']);
                
                $site = 'edit';
             } else {
               // New or not all filled out?
               if (checkPG('check')) {
                 $template->assign('ERROR', 1);
               }
        
               // Show Form
               $template->assign('FILE_ADD'   , $config['URL'] . 'add.php'      );
               $template->assign('FILE_ADMIN' , $config['URL'] . 'admin.php'      );
               $template->assign('DIR_SMILIES', $config['SmiliesPath']          );
               $template->assign('DIR_IMAGES' , $config['URL'] . 'templates/Standard/images/');
               $template->assign('NAME'       , htmlentities(stripslashes($_POST['Name'])    , ENT_QUOTES));
               $template->assign('EMAIL'      , htmlentities(stripslashes($_POST['Mail'])    , ENT_QUOTES));
               $template->assign('WEBSITE'    , htmlentities(stripslashes($_POST['Website']), ENT_QUOTES));
               $template->assign('POST'       , htmlentities(stripslashes($_POST['Post']) , ENT_QUOTES));
               $template->assign('POSTID'     , $_POST['PostID']);
               $template->assign('SMILIES'    , getSmilies(23)                  );
               $template->display('Standard/admin_edit.tpl'                  );
             }
            

        }

        // display all posts with edit & delete links
        if ($site == 'edit') {
         $pages    = calcPages(true);   // generate Pages Link Bar
         $allPosts = fetchPosts();  // fetch all posts
         
         // Display the entire guestbook
         $template->assign('COUNT'          , $pages[0]);
         $template->assign('PAGES'          , $pages[1]);
         $template->assign('PAGES_LINK'     , $pages[3]);
         $template->assign('FILE_ADMIN'     , $config['URL'] . 'admin.php');
         $template->assign('DIR_IMAGES'     , $config['URL'] . 'templates/Standard/images/');
         $template->assign('ITEMS'          , $allPosts                 );
         $template->assign('L_NEW_POST'     , $lang['New_post']);
         $template->assign('L_PAGES'        , $lang['Pages']);
         $template->assign('L_POSTS'        , $lang['Posts']);
         $template->assign('L_ADMIN_EDIT'   , $lang['Admin_edit']);
         $template->assign('L_ADMIN_DELETE' , $lang['Admin_delete']);
         $template->assign('L_ADMIN_CONFIRM', $lang['Admin_confirm']);
         $template->display('Standard/admin_indexGB.tpl'         );

        $DB->disconnect();
                exit();
        }

        // edit post
        startSmilieParser();
        if ($site == 'editPost' && checkPG('PostID', 1, true)) {
        $result = $DB->query('SELECT PostID, IP, Name, EMail, Website, Post, date_format(Date, \'%D %M %Y %T\') AS FDate FROM ' . $config['prefix'] . 'Posts WHERE PostID=' . $_GET['PostID']);
            $row    = $result->fetchRow(DB_FETCHMODE_ASSOC);

        $template->assign('FILE_ADD'   , $config['URL'] . 'add.php'      );
        $template->assign('FILE_ADMIN' , $config['URL'] . 'admin.php'      );
        $template->assign('DIR_SMILIES', $config['SmiliesPath']          );
        $template->assign('DIR_IMAGES' , $config['URL'] . 'templates/Standard/images/');
        $template->assign('NAME'       , $row['Name']);
        $template->assign('POSTID'     , $row['PostID']);
        $template->assign('EMAIL'      , $row['EMail']);
        $template->assign('WEBSITE'    , $row['Website']);
        $template->assign('POST'       , parseSmiliesInverse(str_replace(array('<br>'), array("\n"), $row['Post'])));
        $template->assign('SMILIES'    , getSmilies(23)      );
        $template->assign('L_FORMAT'      , $lang['Format']);
        $template->assign('L_BOLD'        , $lang['Bold']);
        $template->assign('L_ITALIC'      , $lang['Italic']);
        $template->assign('L_UNDERLINE'   , $lang['Underline']);
        $template->assign('L_BACK'        , $lang['Back']);
        $template->assign('L_EMPTY_FIELDS', $lang['Empty_fields']);
        $template->assign('L_NEW_POST'    , $lang['New_post']);
        $template->assign('L_NAME'        , $lang['Name']);
        $template->assign('L_EMAIL'       , $lang['EMail']);
        $template->assign('L_WEBSITE'     , $lang['Website']);
        $template->assign('L_POST'        , $lang['Post']);
        $template->assign('L_SMILIES'     , $lang['Smilies']);
        $template->assign('L_MORE_SMILIES', $lang['More_smilies']);
        $template->assign('L_SAVE'        , $lang['Save']);
        $template->display('Standard/admin_edit.tpl'                  );
        
        $result->free();
        $DB->disconnect();
                exit();
        }
        
        // logout
        if ($site == 'logout') {
            $phpGB_Admin->logout();
            header('Location: ' . $config['URL'] . 'admin.php');
    }
    
        // Cleaning Up
        $DB->disconnect();
 }
?>