<?php

/***************************************************************************
 *   Copyright (C) 2004 by Thomas Flueeli                                  *
 *   cairol@thatrix.net                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/ 
 
/***************************************************************************
 * Version                                                                 *
 *   $Id: index.php,v 1.13 2004/05/18 07:59:55 thatrix Exp $                *
 ***************************************************************************/ 

/***************************************************************************
 * History                                                                 *
 *   06.04.2003 : Initial release [thatrix]                                *
 *   10.04.2003 : Template Engine [thatrix]                                *
 *   13.05.2003 : Text Wrapping [thatrix]                                  *
 *   14.05.2003 : Global Config [thatrix]                                  *
 *   19.05.2003 : Bugfix in PageLink code [thatrix]                        *
 *   28.05.2003 : Removed wrapText [thatrix]                               *
 *   31.07.2003 : "Pages Link Bar" generation outsourced [thatrix]         *
 *   17.11.2003 : FetchPosts outsourced to lib/phpGuestbook.php [thatrix]  *
 *   18.11.2003 : Multi language support [thatrix]                         *
 *   20.11.2003 : Detect Install [thatrix]                                 *
 *   24.11.2003 : Install bugfixes [thatrix]                               *
 *   18.02.2004 : Performance tuning [thatrix]                             *
 ***************************************************************************/

 define('IN_PHPGB', true);
 $phpGB_base = dirname(__FILE__) . '/';
 require_once($phpGB_base . 'lib/phpGuestbook.php');

 // check if guestbook is properly installed
 if (!defined('PHPGB_INSTALLED')) {
        header('Location: ' . str_replace('index.php', '', $_SERVER['PHP_SELF']) . 'install/install.php');
        exit;
 }

 writeHeader();             // write HTML header
 $pages    = calcPages();   // generate Pages Link Bar
 $allPosts = fetchPosts();  // fetch all posts

 $DB->disconnect();
 
 // Display the entire guestbook
 $template->assign('COUNT'     , $pages[0]);
 $template->assign('PAGES'     , $pages[1]);
 $template->assign('PAGES_LINK', $pages[3]);
 $template->assign('FILE_ADD'  , $config['URL'] . 'add.php');
 $template->assign('TITLE'     , $config['Title']          );
 $template->assign('DIR_IMAGES', $config['URL'] . 'templates/' .$config['Theme'] . 'images/');
 $template->assign('ITEMS'     , $allPosts                 );
 $template->assign('L_NEW_POST', $lang['New_post']);
 $template->assign('L_PAGES'   , $lang['Pages']);
 $template->assign('L_POSTS'   , $lang['Posts']);
 $template->assign('L_WRITTEN' , $lang['Written']);
 $template->display($config['Theme'] . 'index.tpl'         );
?>