<?php

/***************************************************************************
 *   Copyright (C) 2004 by Thomas Flueeli                                  *
 *   cairol@thatrix.net                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/ 
 
/***************************************************************************
 * Version                                                                 *
 *   $Id: install.php,v 1.6 2004/05/18 08:01:27 thatrix Exp $                *
 ***************************************************************************/ 

/***************************************************************************
 * History                                                                 *
 *   20.05.2003 : Initial release [thatrix]                                *
 *   20.11.2003 : Complete rewritten [thatrix]                             *
 ***************************************************************************/ 

 /********************************************************************
  * Function    : parseSQL
  * Description : Parse an sql file.
  * Params      : -
  * Return      : -
  ********************************************************************/
 function parseSQL($file = '', $comment = '#', $delimiter = ";\n")
 {
    $output = '';
    $buffer = '';
    
    // try to open the sql file
    if (!$fh = fopen($file, 'r')) {
         die('Fatal Error: Cannot open file (' . $file . ') for reading.');
    }
    
    // parse sql file
    while (!feof($fh)) {
        $buffer = fgets($fh, 1024);
        if (strpos($buffer, $comment) !== 0) {
            $buffer = str_replace('phpGB_', $_POST['prefix'], $buffer);
            $output .= $buffer;
        }
    }
    fclose($fh);       
    
    // split into statements and replace line breaks
    $output = explode($delimiter, $output);
    $output = str_replace(array("\n","\r","\r\n"), array(' '), $output);
    
    return $output;
 }

 define('IN_PHPGB', true);
 $phpGB_base = dirname(__FILE__) . '/../';
 require_once($phpGB_base . 'lib/phpGuestbook.php');
 $error = false;
 
 if(checkPG('url') && checkPG('lang') && checkPG('theme') && checkPG('title') && checkPG('ppp', 0, true) && checkPG('host') && checkPG('dbms') && checkPG('dbname') && checkPG('dbuser') && checkPG('dbpassword') && checkPG('prefix') && checkPG('username') && checkPG('password') && checkPG('confirm') && $_POST['password'] === $_POST['confirm']) {
    
    // save config file 
    $cfile = realpath($phpGB_base . 'config.php');
    $dsn   = $_POST['dbms'] . '://' . $_POST['dbuser'] . ':' . $_POST['dbpassword'] . '@' . $_POST['host'] . '/' . $_POST['dbname'];
    $cdata = "\n<?php\n\t" . '$config[\'DSN\'] = \'' . $dsn . "';\n";
    $cdata .= "\t" . '$config[\'prefix\'] = \'' . $_POST['prefix'] . "';\n";
    $cdata .= "\tdefine('PHPGB_INSTALLED', true);\n";
    $cdata .= '?>';
    
    if (!$fh = fopen($cfile, 'a')) {
         die('Cannot open file (' . $cfile . ') for writing.');
    }
    if (!fwrite($fh, $cdata)) {
        die('Cannot write to file (' . $cfile . ')');
    }
    fclose($fh);
    
    // create tables
    $tables = parseSQL(realpath($phpGB_base . 'install/schemas/' . $_POST['dbms'] . '_schema.sql'));
    $DB = DB::connect($dsn, false);
    foreach ($tables as $table) {
        if (trim($table) != '') {
                $DB->query($table);
        }
    }

    // insert basic data
    $data = parseSQL(realpath($phpGB_base . 'install/schemas/' . $_POST['dbms'] . '_basic.sql'));
    foreach ($data as $insert) {
        if (trim($insert) != '') {
                $DB->query($insert);
        }
    }    

    // insert conf data
    $data = array( array('PostsPerPage', $_POST['ppp']),
                   array('Theme'       , $_POST['theme'] . '/'),
                   array('URL'         , $_POST['url']),
                   array('Title'       , $_POST['title']),
                   array('Language'    , $_POST['lang']));
    $sth  = $DB->prepare('INSERT INTO ' . $_POST['prefix'] . "Config VALUES (?, ?)");
    $DB->executeMultiple($sth, $data);
    $DB->query('INSERT INTO ' . $_POST['prefix'] . 'Users(Username, Password) VALUES(\'' . $_POST['username'] . '\', md5(\'' . $_POST['password'] . '\'))');
    
    $DB->disconnect();
    writeHeader();
    $template->display('Standard/commonHeader.tpl');
?>
<body> 
        <p class="title1">phpGuestbook Installation<br></p>
        <center><p>Installation completed!</p><p><a href="<?php echo $_POST['url']; ?>index.php">proceed to phpGuestbook</a></p></center>
<?php         
    $template->display('Standard/commonFooter.tpl');
    exit(1);
 } else {
        if (checkPG('check')) {
                $error = true;
 }
 }
 writeHeader();
 $template->display('Standard/commonHeader.tpl');
?>
<body> 
        <p class="title1">Welcome to phpGuestbook Installation</p>
        <center>
        <table width="90%" align="center">
            <tr><td align="center">
                Thank you for choosing phpGuestbook. In order to complete this install please fill out the details requested below. Please note that the database you install into should already exist.<br><br>
            </td></tr>
<?php
    if($error)
        echo '<tr><td><div class="error">Error: Please fill out all fields!</p></td></tr>';
?>
        </table>
        <form name="install" method="post" action="<?php echo $_SERVER['PHP_SELF'] ?>">
        <input type="hidden" name="check" value="true">
<?php

    $template->assign('WIDTH', 140);
    $template->assign('DIR_IMAGES', '../templates/Standard/images/');
    $template->assign('TITLE', 'Basic Configuration');
    $template->display('Standard/commonTableStart.tpl'         );
?>  

                        <table border="0" cellspacing="0" cellpadding="0">
                                <tr>
                                        <td align="right"><p class="title2">Language:&nbsp;</p></td>
                                        <td align="left"><select name="lang" size="1" style="width:152px;">
<?php
            $languages = array();
                $dh  = opendir($phpGB_base . 'language');
                while (false !== ($filename = readdir($dh))) {
                        if ($filename != '.' && $filename != '..' && $filename != 'index.html' && $filename != 'CVS') {
                            $languages[] = $filename;
                        }
                }
                closedir($dh);
                sort($languages);
        foreach ($languages as $language) {
            if($language == 'English') {
                echo '<option selected>' . $language . '</option>';
            } else {
                echo '<option>' . $language . '</option>';
            }
        }
?>                                      
                                        </select>
                                        </td>
                                </tr>
                                <tr>
                                        <td align="right"><p class="title2">Theme:&nbsp;</p></td>
                                        <td align="left"><select name="theme" size="1" style="width:152px;">
<?php
            $themes = array();
                $dh  = opendir($phpGB_base . 'templates');
                while (false !== ($filename = readdir($dh))) {
                        if ($filename != '.' && $filename != '..' && $filename != 'index.html' && $filename != 'CVS') {
                            $themes[] = $filename;
                        }
                }
                closedir($dh);
                sort($themes);
        foreach ($themes as $theme) {
            if($theme == 'Standard') {
                echo '<option selected>' . $theme . '</option>';
            } else {
                echo '<option>' . $theme . '</option>';
            }
        }
?>                                      
                                        </select>
                                        </td>
                                </tr>
                                <tr>
                                        <td align="right"><p class="title2">Title:&nbsp;</p></td>
                                        <td align="left"><input type="text" name="title" style="width:150px;" value="<?php if(trim($_POST['title']) != '') echo $_POST['title']; else echo 'phpGuestbook'; ?>" size="25"></td>
                                </tr>
                                <tr>
                                        <td align="right"><p class="title2">Posts per Page:&nbsp;</p></td>
                                        <td align="left"><input type="text" name="ppp" style="width:150px;" value="<?php if(trim($_POST['ppp']) != '') echo $_POST['ppp']; else echo '5' ?>" size="25"></td>
                                </tr>
                        </table>
<?php
    $template->assign('WIDTH', 140);
    $template->assign('DIR_IMAGES', '../templates/Standard/images/');
    $template->display('Standard/commonTableEnd.tpl'         );
?>
<br><br>
<?php
    $template->assign('WIDTH', 140);
    $template->assign('DIR_IMAGES', '../templates/Standard/images/');
    $template->assign('TITLE', 'Database Configuration');
    $template->display('Standard/commonTableStart.tpl'         );
?>                      
                        <table border="0" cellspacing="0" cellpadding="0">
                                <tr>
                                        <td align="right"><p class="title2">Database Type:&nbsp;</p></td>
                                        <td align="left"><select name="dbms" size="1" style="width:152px;">
                                        <option selected value="mysql">MySQL</option>
                                        <option value="pgsql">PostgreSQL</option>
                                        <option value="ibase">InterBase</option>
                                        <option value="msql">Mini SQL</option>
                                        <option value="mssql">Microsoft SQL Server</option>
                                        <option value="oci8">Oracle 7/8/8i</option>
                                        <option value="odbc">ODBC</option>
                                        <option value="sybase">SyBase</option>
                                        <option value="ifx">Informix</option>
                                        <option value="fbsql">FrontBase</option>
                                        </select></td>
                                </tr>
                                <tr>
                                        <td align="right"><p class="title2">Database Server Hostname:&nbsp;</p></td>
                                        <td align="left"><input type="text" name="host" style="width:150px;" value="<?php if(trim($_POST['host']) != '') echo $_POST['host']; else echo 'localhost' ?>" size="25"></td>
                                </tr>
                                <tr>
                                        <td align="right"><p class="title2">Database Name:&nbsp;</p></td>
                                        <td align="left"><input type="text" style="width:150px;" name="dbname" value="<?php echo $_POST['dbname'] ?>" size="25"></td>
                                </tr>
                                <tr>
                                        <td align="right"><p class="title2">Database Username:&nbsp;</p></td>
                                        <td align="left"><input type="text" style="width:150px;" name="dbuser" value="<?php echo $_POST['dbuser'] ?>" size="25"></td>
                                </tr>
                                <tr>
                                        <td align="right"><p class="title2">Database Password:&nbsp;</p></td>
                                        <td align="left"><input type="password" style="width:150px;" name="dbpassword" value="<?php echo $_POST['dbpassword'] ?>" size="25"></td>
                                </tr>
                                <tr>
                                        <td align="right"><p class="title2">Prefix for tables in database:&nbsp;</p></td>
                                        <td align="left"><input type="text" style="width:150px;" name="prefix" value="<?php if(trim($_POST['prefix']) != '') echo $_POST['prefix']; else echo 'phpGB_' ?>" size="25"></td>
                                </tr>
                        </table>
<?php
    $template->assign('WIDTH', 140);
    $template->assign('DIR_IMAGES', '../templates/Standard/images/');
    $template->display('Standard/commonTableEnd.tpl'         );
?>
<br><br>
<?php

    $template->assign('WIDTH', 140);
    $template->assign('DIR_IMAGES', '../templates/Standard/images/');
    $template->assign('TITLE', 'Admin Configuration');
    $template->display('Standard/commonTableStart.tpl'         );
?>                      
                        <table border="0" cellspacing="0" cellpadding="0">
                                <tr>
                                        <td align="right"><p class="title2">Script path:&nbsp;</p></td>
                                        <td align="left"><input type="text" name="url" style="width:150px;" value="<?php if(trim($_POST['url']) != '') echo $_POST['url']; else echo str_replace('install/install.php', '', $_SERVER['PHP_SELF']); ?>" size="25"></td>
                                </tr>
                                <tr>
                                        <td align="right"><p class="title2">Administrator Username:&nbsp;</p></td>
                                        <td align="left"><input type="text" style="width:150px;" name="username" value="<?php if(trim($_POST['username']) != '') echo $_POST['username']; else echo 'phpGB_Admin' ?>" size="25"></td>
                                </tr>
                                <tr>
                                        <td align="right"><p class="title2">Administrator Password:&nbsp;</p></td>
                                        <td align="left"><input type="password" style="width:150px;" name="password" value="<?php echo $_POST['password'] ?>" size="25"></td>
                                </tr>
                                <tr>
                                        <td align="right"><p class="title2">Administrator Password [confirm]:&nbsp;</p></td>
                                        <td align="left"><input type="password" style="width:150px;" name="confirm" value="<?php echo $_POST['confirm'] ?>" size="25"></td>
                                </tr>
                        </table>
<?php
    $template->assign('WIDTH', 140);
    $template->assign('DIR_IMAGES', '../templates/Standard/images/');
    $template->display('Standard/commonTableEnd.tpl'         );
?>
<br>
<input type="submit" value="Start Install">
<?php
    $template->display('Standard/commonFooter.tpl');
?>